xref: /netbsd/external/gpl3/autoconf/dist/maint.mk (revision f3dc700a)
1# -*-Makefile-*-
2# This Makefile fragment tries to be general-purpose enough to be
3# used by many projects via the gnulib maintainer-makefile module.
4
5## Copyright (C) 2001-2012 Free Software Foundation, Inc.
6##
7## This program is free software: you can redistribute it and/or modify
8## it under the terms of the GNU General Public License as published by
9## the Free Software Foundation, either version 3 of the License, or
10## (at your option) any later version.
11##
12## This program is distributed in the hope that it will be useful,
13## but WITHOUT ANY WARRANTY; without even the implied warranty of
14## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15## GNU General Public License for more details.
16##
17## You should have received a copy of the GNU General Public License
18## along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20# This is reported not to work with make-3.79.1
21# ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22ME := maint.mk
23
24# Diagnostic for continued use of deprecated variable.
25# Remove in 2013
26ifneq ($(build_aux),)
27 $(error "$(ME): \
28set $$(_build-aux) relative to $$(srcdir) instead of $$(build_aux)")
29endif
30
31# Do not save the original name or timestamp in the .tar.gz file.
32# Use --rsyncable if available.
33gzip_rsyncable := \
34  $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
35    && printf %s --rsyncable)
36GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
37
38GIT = git
39VC = $(GIT)
40
41VC_LIST = $(srcdir)/$(_build-aux)/vc-list-files -C $(srcdir)
42
43# You can override this variable in cfg.mk to set your own regexp
44# matching files to ignore.
45VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
46
47# This is to preprocess robustly the output of $(VC_LIST), so that even
48# when $(srcdir) is a pathological name like "....", the leading sed command
49# removes only the intended prefix.
50_dot_escaped_srcdir = $(subst .,\.,$(srcdir))
51
52# Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
53# when $(srcdir) is not ".".
54ifeq ($(srcdir),.)
55_prepend_srcdir_prefix =
56else
57_prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
58endif
59
60# In order to be able to consistently filter "."-relative names,
61# (i.e., with no $(srcdir) prefix), this definition is careful to
62# remove any $(srcdir) prefix, and to restore what it removes.
63_sc_excl = \
64  $(if $(exclude_file_name_regexp--$@),$(exclude_file_name_regexp--$@),^$$)
65VC_LIST_EXCEPT = \
66  $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
67	| if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
68	  else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
69	| grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
70	$(_prepend_srcdir_prefix)
71
72ifeq ($(origin prev_version_file), undefined)
73  prev_version_file = $(srcdir)/.prev-version
74endif
75
76PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
77VERSION_REGEXP = $(subst .,\.,$(VERSION))
78PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
79
80ifeq ($(VC),$(GIT))
81this-vc-tag = v$(VERSION)
82this-vc-tag-regexp = v$(VERSION_REGEXP)
83else
84tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
85tag-this-version = $(subst .,_,$(VERSION))
86this-vc-tag = $(tag-package)-$(tag-this-version)
87this-vc-tag-regexp = $(this-vc-tag)
88endif
89my_distdir = $(PACKAGE)-$(VERSION)
90
91# Old releases are stored here.
92release_archive_dir ?= ../release
93
94# Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
95# Use alpha.gnu.org for alpha and beta releases.
96# Use ftp.gnu.org for stable releases.
97gnu_ftp_host-alpha = alpha.gnu.org
98gnu_ftp_host-beta = alpha.gnu.org
99gnu_ftp_host-stable = ftp.gnu.org
100gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
101
102ifeq ($(gnu_rel_host),ftp.gnu.org)
103url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
104else
105url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
106endif
107
108# Override this in cfg.mk if you are using a different format in your
109# NEWS file.
110today = $(shell date +%Y-%m-%d)
111
112# Select which lines of NEWS are searched for $(news-check-regexp).
113# This is a sed line number spec.  The default says that we search
114# lines 1..10 of NEWS for $(news-check-regexp).
115# If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
116news-check-lines-spec ?= 1,10
117news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
118
119# Prevent programs like 'sort' from considering distinct strings to be equal.
120# Doing it here saves us from having to set LC_ALL elsewhere in this file.
121export LC_ALL = C
122
123## --------------- ##
124## Sanity checks.  ##
125## --------------- ##
126
127_cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
128
129# Collect the names of rules starting with 'sc_'.
130syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
131			$(srcdir)/$(ME) $(_cfg_mk)))
132.PHONY: $(syntax-check-rules)
133
134ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
135local-checks-available += $(syntax-check-rules)
136else
137local-checks-available += no-vc-detected
138no-vc-detected:
139	@echo "No version control files detected; skipping syntax check"
140endif
141.PHONY: $(local-checks-available)
142
143# Arrange to print the name of each syntax-checking rule just before running it.
144$(syntax-check-rules): %: %.m
145sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
146.PHONY: $(sc_m_rules_)
147$(sc_m_rules_):
148	@echo $(patsubst sc_%.m, %, $@)
149	@date +%s.%N > .sc-start-$(basename $@)
150
151# Compute and print the elapsed time for each syntax-check rule.
152sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
153.PHONY: $(sc_z_rules_)
154$(sc_z_rules_): %.z: %
155	@end=$$(date +%s.%N);						\
156	start=$$(cat .sc-start-$*);					\
157	rm -f .sc-start-$*;						\
158	awk -v s=$$start -v e=$$end					\
159	  'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
160
161# The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
162# that computes and prints elapsed time.
163local-check :=								\
164  $(patsubst sc_%, sc_%.z,						\
165    $(filter-out $(local-checks-to-skip), $(local-checks-available)))
166
167syntax-check: $(local-check)
168
169# _sc_search_regexp
170#
171# This macro searches for a given construct in the selected files and
172# then takes some action.
173#
174# Parameters (shell variables):
175#
176#  prohibit | require
177#
178#     Regular expression (ERE) denoting either a forbidden construct
179#     or a required construct.  Those arguments are exclusive.
180#
181#  exclude
182#
183#     Regular expression (ERE) denoting lines to ignore that matched
184#     a prohibit construct.  For example, this can be used to exclude
185#     comments that mention why the nearby code uses an alternative
186#     construct instead of the simpler prohibited construct.
187#
188#  in_vc_files | in_files
189#
190#     grep-E-style regexp denoting the files to check.  If no files
191#     are specified the default are all the files that are under
192#     version control.
193#
194#  containing | non_containing
195#
196#     Select the files (non) containing strings matching this regexp.
197#     If both arguments are specified then CONTAINING takes
198#     precedence.
199#
200#  with_grep_options
201#
202#     Extra options for grep.
203#
204#  ignore_case
205#
206#     Ignore case.
207#
208#  halt
209#
210#     Message to display before to halting execution.
211#
212# Finally, you may exempt files based on an ERE matching file names.
213# For example, to exempt from the sc_space_tab check all files with the
214# .diff suffix, set this Make variable:
215#
216# exclude_file_name_regexp--sc_space_tab = \.diff$
217#
218# Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
219# when filtering by name via in_files, we explicitly filter out matching
220# names here as well.
221
222# Initialize each, so that envvar settings cannot interfere.
223export require =
224export prohibit =
225export exclude =
226export in_vc_files =
227export in_files =
228export containing =
229export non_containing =
230export halt =
231export with_grep_options =
232
233# By default, _sc_search_regexp does not ignore case.
234export ignore_case =
235_ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
236
237define _sc_say_and_exit
238   dummy=; : so we do not need a semicolon before each use;		\
239   { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
240endef
241
242define _sc_search_regexp
243   dummy=; : so we do not need a semicolon before each use;		\
244									\
245   : Check arguments;							\
246   test -n "$$prohibit" && test -n "$$require"				\
247     && { msg='Cannot specify both prohibit and require'		\
248          $(_sc_say_and_exit) } || :;					\
249   test -z "$$prohibit" && test -z "$$require"				\
250     && { msg='Should specify either prohibit or require'		\
251          $(_sc_say_and_exit) } || :;					\
252   test -z "$$prohibit" && test -n "$$exclude"				\
253     && { msg='Use of exclude requires a prohibit pattern'		\
254          $(_sc_say_and_exit) } || :;					\
255   test -n "$$in_vc_files" && test -n "$$in_files"			\
256     && { msg='Cannot specify both in_vc_files and in_files'		\
257          $(_sc_say_and_exit) } || :;					\
258   test "x$$halt" != x							\
259     || { msg='halt not defined' $(_sc_say_and_exit) };			\
260									\
261   : Filter by file name;						\
262   if test -n "$$in_files"; then					\
263     files=$$(find $(srcdir) | grep -E "$$in_files"			\
264              | grep -Ev '$(exclude_file_name_regexp--$@)');		\
265   else									\
266     files=$$($(VC_LIST_EXCEPT));					\
267     if test -n "$$in_vc_files"; then					\
268       files=$$(echo "$$files" | grep -E "$$in_vc_files");		\
269     fi;								\
270   fi;									\
271									\
272   : Filter by content;							\
273   test -n "$$files" && test -n "$$containing"				\
274     && { files=$$(grep -l "$$containing" $$files); } || :;		\
275   test -n "$$files" && test -n "$$non_containing"			\
276     && { files=$$(grep -vl "$$non_containing" $$files); } || :;	\
277									\
278   : Check for the construct;						\
279   if test -n "$$files"; then						\
280     if test -n "$$prohibit"; then					\
281       grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
282         | grep -vE "$${exclude:-^$$}"					\
283         && { msg="$$halt" $(_sc_say_and_exit) } || :;			\
284     else								\
285       grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
286           | grep .							\
287         && { msg="$$halt" $(_sc_say_and_exit) } || :;			\
288     fi									\
289   else :;								\
290   fi || :;
291endef
292
293sc_avoid_if_before_free:
294	@$(srcdir)/$(_build-aux)/useless-if-before-free			\
295		$(useless_free_options)					\
296	    $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) &&	\
297	  { echo '$(ME): found useless "if" before "free" above' 1>&2;	\
298	    exit 1; } || :
299
300sc_cast_of_argument_to_free:
301	@prohibit='\<free *\( *\(' halt="don't cast free argument"	\
302	  $(_sc_search_regexp)
303
304sc_cast_of_x_alloc_return_value:
305	@prohibit='\*\) *x(m|c|re)alloc\>'				\
306	halt="don't cast x*alloc return value"				\
307	  $(_sc_search_regexp)
308
309sc_cast_of_alloca_return_value:
310	@prohibit='\*\) *alloca\>'					\
311	halt="don't cast alloca return value"				\
312	  $(_sc_search_regexp)
313
314sc_space_tab:
315	@prohibit='[ ]	'						\
316	halt='found SPACE-TAB sequence; remove the SPACE'		\
317	  $(_sc_search_regexp)
318
319# Don't use *scanf or the old ato* functions in "real" code.
320# They provide no error checking mechanism.
321# Instead, use strto* functions.
322sc_prohibit_atoi_atof:
323	@prohibit='\<([fs]?scanf|ato([filq]|ll)) *\('				\
324	halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q'	\
325	  $(_sc_search_regexp)
326
327# Use STREQ rather than comparing strcmp == 0, or != 0.
328sp_ = strcmp *\(.+\)
329sc_prohibit_strcmp:
330	@prohibit='! *strcmp *\(|\<$(sp_) *[!=]=|[!=]= *$(sp_)'		\
331	exclude=':# *define STRN?EQ\('					\
332	halt='$(ME): replace strcmp calls above with STREQ/STRNEQ'	\
333	  $(_sc_search_regexp)
334
335# Pass EXIT_*, not number, to usage, exit, and error (when exiting)
336# Convert all uses automatically, via these two commands:
337# git grep -l '\<exit *(1)' \
338#  | grep -vEf .x-sc_prohibit_magic_number_exit \
339#  | xargs --no-run-if-empty \
340#      perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
341# git grep -l '\<exit *(0)' \
342#  | grep -vEf .x-sc_prohibit_magic_number_exit \
343#  | xargs --no-run-if-empty \
344#      perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
345sc_prohibit_magic_number_exit:
346	@prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,'	\
347	halt='use EXIT_* values rather than magic number'			\
348	  $(_sc_search_regexp)
349
350# Using EXIT_SUCCESS as the first argument to error is misleading,
351# since when that parameter is 0, error does not exit.  Use '0' instead.
352sc_error_exit_success:
353	@prohibit='error *\(EXIT_SUCCESS,'				\
354	in_vc_files='\.[chly]$$'					\
355	halt='found error (EXIT_SUCCESS'				\
356	 $(_sc_search_regexp)
357
358# "FATAL:" should be fully upper-cased in error messages
359# "WARNING:" should be fully upper-cased, or fully lower-cased
360sc_error_message_warn_fatal:
361	@grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))		\
362	    | grep -E '"Warning|"Fatal|"fatal' &&			\
363	  { echo '$(ME): use FATAL, WARNING or warning'	1>&2;		\
364	    exit 1; } || :
365
366# Error messages should not start with a capital letter
367sc_error_message_uppercase:
368	@grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))		\
369	    | grep -E '"[A-Z]'						\
370	    | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' &&		\
371	  { echo '$(ME): found capitalized error message' 1>&2;		\
372	    exit 1; } || :
373
374# Error messages should not end with a period
375sc_error_message_period:
376	@grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))		\
377	    | grep -E '[^."]\."' &&					\
378	  { echo '$(ME): found error message ending in period' 1>&2;	\
379	    exit 1; } || :
380
381sc_file_system:
382	@prohibit=file''system						\
383	ignore_case=1							\
384	halt='found use of "file''system"; spell it "file system"'	\
385	  $(_sc_search_regexp)
386
387# Don't use cpp tests of this symbol.  All code assumes config.h is included.
388sc_prohibit_have_config_h:
389	@prohibit='^# *if.*HAVE''_CONFIG_H'				\
390	halt='found use of HAVE''_CONFIG_H; remove'			\
391	  $(_sc_search_regexp)
392
393# Nearly all .c files must include <config.h>.  However, we also permit this
394# via inclusion of a package-specific header, if cfg.mk specified one.
395# config_h_header must be suitable for grep -E.
396config_h_header ?= <config\.h>
397sc_require_config_h:
398	@require='^# *include $(config_h_header)'			\
399	in_vc_files='\.c$$'						\
400	halt='the above files do not include <config.h>'		\
401	  $(_sc_search_regexp)
402
403# You must include <config.h> before including any other header file.
404# This can possibly be via a package-specific header, if given by cfg.mk.
405sc_require_config_h_first:
406	@if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then	\
407	  fail=0;							\
408	  for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do		\
409	    grep '^# *include\>' $$i | sed 1q				\
410		| grep -E '^# *include $(config_h_header)' > /dev/null	\
411	      || { echo $$i; fail=1; };					\
412	  done;								\
413	  test $$fail = 1 &&						\
414	    { echo '$(ME): the above files include some other header'	\
415		'before <config.h>' 1>&2; exit 1; } || :;		\
416	else :;								\
417	fi
418
419sc_prohibit_HAVE_MBRTOWC:
420	@prohibit='\bHAVE_MBRTOWC\b'					\
421	halt="do not use $$prohibit; it is always defined"		\
422	  $(_sc_search_regexp)
423
424# To use this "command" macro, you must first define two shell variables:
425# h: the header name, with no enclosing <> or ""
426# re: a regular expression that matches IFF something provided by $h is used.
427define _sc_header_without_use
428  dummy=; : so we do not need a semicolon before each use;		\
429  h_esc=`echo '[<"]'"$$h"'[">]'|sed 's/\./\\\\./g'`;			\
430  if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then		\
431    files=$$(grep -l '^# *include '"$$h_esc"				\
432	     $$($(VC_LIST_EXCEPT) | grep '\.c$$')) &&			\
433    grep -LE "$$re" $$files | grep . &&					\
434      { echo "$(ME): the above files include $$h but don't use it"	\
435	1>&2; exit 1; } || :;						\
436  else :;								\
437  fi
438endef
439
440# Prohibit the inclusion of assert.h without an actual use of assert.
441sc_prohibit_assert_without_use:
442	@h='assert.h' re='\<assert *\(' $(_sc_header_without_use)
443
444# Prohibit the inclusion of close-stream.h without an actual use.
445sc_prohibit_close_stream_without_use:
446	@h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)
447
448# Prohibit the inclusion of getopt.h without an actual use.
449sc_prohibit_getopt_without_use:
450	@h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
451
452# Don't include quotearg.h unless you use one of its functions.
453sc_prohibit_quotearg_without_use:
454	@h='quotearg.h' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
455
456# Don't include quote.h unless you use one of its functions.
457sc_prohibit_quote_without_use:
458	@h='quote.h' re='\<quote((_n)? *\(|_quoting_options\>)' \
459	  $(_sc_header_without_use)
460
461# Don't include this header unless you use one of its functions.
462sc_prohibit_long_options_without_use:
463	@h='long-options.h' re='\<parse_long_options *\(' \
464	  $(_sc_header_without_use)
465
466# Don't include this header unless you use one of its functions.
467sc_prohibit_inttostr_without_use:
468	@h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
469	  $(_sc_header_without_use)
470
471# Don't include this header unless you use one of its functions.
472sc_prohibit_ignore_value_without_use:
473	@h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
474	  $(_sc_header_without_use)
475
476# Don't include this header unless you use one of its functions.
477sc_prohibit_error_without_use:
478	@h='error.h' \
479	re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
480	  $(_sc_header_without_use)
481
482# Don't include xalloc.h unless you use one of its functions.
483# Consider these symbols:
484# perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
485# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
486# Divide into two sets on case, and filter each through this:
487# | sort | perl -MRegexp::Assemble -le \
488#  'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
489# Note this was produced by the above:
490# _xa1 = \
491#x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
492# But we can do better, in at least two ways:
493# 1) take advantage of two "dup"-suffixed strings:
494# x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
495# 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
496# "char|[cmz]"
497# x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
498_xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
499_xa2 = X([CZ]|N?M)ALLOC
500sc_prohibit_xalloc_without_use:
501	@h='xalloc.h' \
502	re='\<($(_xa1)|$(_xa2)) *\('\
503	  $(_sc_header_without_use)
504
505# Extract function names:
506# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
507_hash_re = \
508clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
509_hash_fn = \<($(_hash_re)) *\(
510_hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
511sc_prohibit_hash_without_use:
512	@h='hash.h' \
513	re='$(_hash_fn)|$(_hash_struct)'\
514	  $(_sc_header_without_use)
515
516sc_prohibit_cloexec_without_use:
517	@h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
518	  $(_sc_header_without_use)
519
520sc_prohibit_posixver_without_use:
521	@h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)
522
523sc_prohibit_same_without_use:
524	@h='same.h' re='\<same_name *\(' $(_sc_header_without_use)
525
526sc_prohibit_hash_pjw_without_use:
527	@h='hash-pjw.h' \
528	re='\<hash_pjw\>' \
529	  $(_sc_header_without_use)
530
531sc_prohibit_safe_read_without_use:
532	@h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
533	  $(_sc_header_without_use)
534
535sc_prohibit_argmatch_without_use:
536	@h='argmatch.h' \
537	re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
538	  $(_sc_header_without_use)
539
540sc_prohibit_canonicalize_without_use:
541	@h='canonicalize.h' \
542	re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode|file_name)' \
543	  $(_sc_header_without_use)
544
545sc_prohibit_root_dev_ino_without_use:
546	@h='root-dev-ino.h' \
547	re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
548	  $(_sc_header_without_use)
549
550sc_prohibit_openat_without_use:
551	@h='openat.h' \
552	re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
553	  $(_sc_header_without_use)
554
555# Prohibit the inclusion of c-ctype.h without an actual use.
556ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
557|isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
558sc_prohibit_c_ctype_without_use:
559	@h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
560	  $(_sc_header_without_use)
561
562_empty =
563_sp = $(_empty) $(_empty)
564# The following list was generated by running:
565# man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
566#   | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
567_sig_functions = \
568  bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
569  sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
570  siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
571  sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
572_sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
573# The following were extracted from "man signal.h" manually.
574_sig_types_and_consts =							\
575  MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK		\
576  SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL		\
577  SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE	\
578  SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t	\
579  sigstack sigval stack_t ucontext_t
580# generated via this:
581# perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
582_sig_names =								\
583  SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT	\
584  SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL	\
585  SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP	\
586  SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR	\
587  SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS	\
588  SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1	\
589  SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW	\
590  SIGXCPU SIGXFSZ
591_sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
592
593# Prohibit the inclusion of signal.h without an actual use.
594sc_prohibit_signal_without_use:
595	@h='signal.h'							\
596	re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>'		\
597	  $(_sc_header_without_use)
598
599# Don't include stdio--.h unless you use one of its functions.
600sc_prohibit_stdio--_without_use:
601	@h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\('		\
602	  $(_sc_header_without_use)
603
604# Don't include stdio-safer.h unless you use one of its functions.
605sc_prohibit_stdio-safer_without_use:
606	@h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\('	\
607	  $(_sc_header_without_use)
608
609# Prohibit the inclusion of strings.h without a sensible use.
610# Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
611sc_prohibit_strings_without_use:
612	@h='strings.h'							\
613	re='\<(strn?casecmp|ffs(ll)?)\>'				\
614	  $(_sc_header_without_use)
615
616# Get the list of symbol names with this:
617# perl -lne '/^# *define ([A-Z]\w+)\(/ and print $1' lib/intprops.h|fmt
618_intprops_names =							\
619  TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT		\
620  TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM		\
621  INT_BITS_STRLEN_BOUND INT_STRLEN_BOUND INT_BUFSIZE_BOUND		\
622  INT_ADD_RANGE_OVERFLOW INT_SUBTRACT_RANGE_OVERFLOW			\
623  INT_NEGATE_RANGE_OVERFLOW INT_MULTIPLY_RANGE_OVERFLOW			\
624  INT_DIVIDE_RANGE_OVERFLOW INT_REMAINDER_RANGE_OVERFLOW		\
625  INT_LEFT_SHIFT_RANGE_OVERFLOW INT_ADD_OVERFLOW INT_SUBTRACT_OVERFLOW	\
626  INT_NEGATE_OVERFLOW INT_MULTIPLY_OVERFLOW INT_DIVIDE_OVERFLOW		\
627  INT_REMAINDER_OVERFLOW INT_LEFT_SHIFT_OVERFLOW
628_intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
629# Prohibit the inclusion of intprops.h without an actual use.
630sc_prohibit_intprops_without_use:
631	@h='intprops.h'							\
632	re='\<($(_intprops_syms_re)) *\('				\
633	  $(_sc_header_without_use)
634
635_stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
636# Prohibit the inclusion of stddef.h without an actual use.
637sc_prohibit_stddef_without_use:
638	@h='stddef.h'							\
639	re='\<($(_stddef_syms_re))\>'					\
640	  $(_sc_header_without_use)
641
642_de1 = dirfd|(close|(fd)?open|read|rewind|seek|tell)dir(64)?(_r)?
643_de2 = (versionsort|struct dirent|getdirentries|alphasort|scandir(at)?)(64)?
644_de3 = MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
645_dirent_syms_re = $(_de1)|$(_de2)|$(_de3)
646# Prohibit the inclusion of dirent.h without an actual use.
647sc_prohibit_dirent_without_use:
648	@h='dirent.h'							\
649	re='\<($(_dirent_syms_re))\>'					\
650	  $(_sc_header_without_use)
651
652# Prohibit the inclusion of verify.h without an actual use.
653sc_prohibit_verify_without_use:
654	@h='verify.h'							\
655	re='\<(verify(true|expr)?|static_assert) *\('			\
656	  $(_sc_header_without_use)
657
658# Don't include xfreopen.h unless you use one of its functions.
659sc_prohibit_xfreopen_without_use:
660	@h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)
661
662sc_obsolete_symbols:
663	@prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>'			\
664	halt='do not use HAVE''_FCNTL_H or O'_NDELAY			\
665	  $(_sc_search_regexp)
666
667# FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
668
669# Each nonempty ChangeLog line must start with a year number, or a TAB.
670sc_changelog:
671	@prohibit='^[^12	]'					\
672	in_vc_files='^ChangeLog$$'					\
673	halt='found unexpected prefix in a ChangeLog'			\
674	  $(_sc_search_regexp)
675
676# Ensure that each .c file containing a "main" function also
677# calls set_program_name.
678sc_program_name:
679	@require='set_program_name *\(m?argv\[0\]\);'			\
680	in_vc_files='\.c$$'						\
681	containing='\<main *('						\
682	halt='the above files do not call set_program_name'		\
683	  $(_sc_search_regexp)
684
685# Ensure that each .c file containing a "main" function also
686# calls bindtextdomain.
687sc_bindtextdomain:
688	@require='bindtextdomain *\('					\
689	in_vc_files='\.c$$'						\
690	containing='\<main *('						\
691	halt='the above files do not call bindtextdomain'		\
692	  $(_sc_search_regexp)
693
694# Require that the final line of each test-lib.sh-using test be this one:
695# Exit $fail
696# Note: this test requires GNU grep's --label= option.
697Exit_witness_file ?= tests/test-lib.sh
698Exit_base := $(notdir $(Exit_witness_file))
699sc_require_test_exit_idiom:
700	@if test -f $(srcdir)/$(Exit_witness_file); then		\
701	  die=0;							\
702	  for i in $$(grep -l -F 'srcdir/$(Exit_base)'			\
703		$$($(VC_LIST) tests)); do				\
704	    tail -n1 $$i | grep '^Exit .' > /dev/null			\
705	      && : || { die=1; echo $$i; }				\
706	  done;								\
707	  test $$die = 1 &&						\
708	    { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
709	      echo 1>&2 'Exit something';				\
710	      exit 1; } || :;						\
711	fi
712
713sc_trailing_blank:
714	@prohibit='[	 ]$$'						\
715	halt='found trailing blank(s)'					\
716	  $(_sc_search_regexp)
717
718# Match lines like the following, but where there is only one space
719# between the options and the description:
720#   -D, --all-repeated[=delimit-method]  print all duplicate lines\n
721longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
722sc_two_space_separator_in_usage:
723	@prohibit='^   *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$'		\
724	halt='help2man requires at least two spaces between an option and its description'\
725	  $(_sc_search_regexp)
726
727# A regexp matching function names like "error" that may be used
728# to emit translatable messages.
729_gl_translatable_diag_func_re ?= error
730
731# Look for diagnostics that aren't marked for translation.
732# This won't find any for which error's format string is on a separate line.
733sc_unmarked_diagnostics:
734	@prohibit='\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
735	exclude='(_|ngettext ?)\('					\
736	halt='$(ME): found unmarked diagnostic(s)'			\
737	  $(_sc_search_regexp)
738
739# Avoid useless parentheses like those in this example:
740# #if defined (SYMBOL) || defined (SYM2)
741sc_useless_cpp_parens:
742	@prohibit='^# *if .*defined *\('				\
743	halt='found useless parentheses in cpp directive'		\
744	  $(_sc_search_regexp)
745
746# List headers for which HAVE_HEADER_H is always true, assuming you are
747# using the appropriate gnulib module.  CAUTION: for each "unnecessary"
748# #if HAVE_HEADER_H that you remove, be sure that your project explicitly
749# requires the gnulib module that guarantees the usability of that header.
750gl_assured_headers_ = \
751  cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
752
753# Convert the list of names to upper case, and replace each space with "|".
754az_ = abcdefghijklmnopqrstuvwxyz
755AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
756gl_header_upper_case_or_ =						\
757  $$($(gl_assured_headers_)						\
758    | tr $(az_)/.- $(AZ_)___						\
759    | tr -s ' ' '|'							\
760    )
761sc_prohibit_always_true_header_tests:
762	@or=$(gl_header_upper_case_or_);				\
763	re="HAVE_($$or)_H";						\
764	prohibit='\<'"$$re"'\>'						\
765	halt=$$(printf '%s\n'						\
766	'do not test the above HAVE_<header>_H symbol(s);'		\
767	'  with the corresponding gnulib module, they are always true')	\
768	  $(_sc_search_regexp)
769
770# ==================================================================
771gl_other_headers_ ?= \
772  intprops.h	\
773  openat.h	\
774  stat-macros.h
775
776# Perl -lne code to extract "significant" cpp-defined symbols from a
777# gnulib header file, eliminating a few common false-positives.
778# The exempted names below are defined only conditionally in gnulib,
779# and hence sometimes must/may be defined in application code.
780gl_extract_significant_defines_ = \
781  /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
782    && $$2 !~ /(?:rpl_|_used_without_)/\
783    && $$1 !~ /^(?:NSIG|ENODATA)$$/\
784    && $$1 !~ /^(?:SA_RESETHAND|SA_RESTART)$$/\
785    and print $$1
786
787# Create a list of regular expressions matching the names
788# of macros that are guaranteed to be defined by parts of gnulib.
789define def_sym_regex
790	gen_h=$(gl_generated_headers_);					\
791	(cd $(gnulib_dir)/lib;						\
792	  for f in *.in.h $(gl_other_headers_); do			\
793	    test -f $$f							\
794	      && perl -lne '$(gl_extract_significant_defines_)' $$f;	\
795	  done;								\
796	) | sort -u							\
797	  | sed 's/^/^ *# *(define|undef)  */;s/$$/\\>/'
798endef
799
800# Don't define macros that we already get from gnulib header files.
801sc_prohibit_always-defined_macros:
802	@if test -d $(gnulib_dir); then					\
803	  case $$(echo all: | grep -l -f - Makefile) in Makefile);; *)	\
804	    echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;;	\
805	  esac;								\
806	  $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT))		\
807	    && { echo '$(ME): define the above via some gnulib .h file'	\
808		  1>&2;  exit 1; } || :;				\
809	fi
810# ==================================================================
811
812# Prohibit checked in backup files.
813sc_prohibit_backup_files:
814	@$(VC_LIST) | grep '~$$' &&				\
815	  { echo '$(ME): found version controlled backup file' 1>&2;	\
816	    exit 1; } || :
817
818# Require the latest GPL.
819sc_GPL_version:
820	@prohibit='either ''version [^3]'				\
821	halt='GPL vN, N!=3'						\
822	  $(_sc_search_regexp)
823
824# Require the latest GFDL.  Two regexp, since some .texi files end up
825# line wrapping between 'Free Documentation License,' and 'Version'.
826_GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
827sc_GFDL_version:
828	@prohibit='$(_GFDL_regexp)'					\
829	halt='GFDL vN, N!=3'						\
830	  $(_sc_search_regexp)
831
832# Don't use Texinfo's @acronym{}.
833# http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
834texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
835sc_texinfo_acronym:
836	@prohibit='@acronym\{'						\
837	in_vc_files='$(texinfo_suffix_re_)'				\
838	halt='found use of Texinfo @acronym{}'				\
839	  $(_sc_search_regexp)
840
841cvs_keywords = \
842  Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
843
844sc_prohibit_cvs_keyword:
845	@prohibit='\$$($(cvs_keywords))\$$'				\
846	halt='do not use CVS keyword expansion'				\
847	  $(_sc_search_regexp)
848
849# This Perl code is slightly obfuscated.  Not only is each "$" doubled
850# because it's in a Makefile, but the $$c's are comments;  we cannot
851# use "#" due to the way the script ends up concatenated onto one line.
852# It would be much more concise, and would produce better output (including
853# counts) if written as:
854#   perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
855# but that would be far less efficient, reading the entire contents
856# of each file, rather than just the last two bytes of each.
857# In addition, while the code below detects both blank lines and a missing
858# newline at EOF, the above detects only the former.
859#
860# This is a perl script that is expected to be the single-quoted argument
861# to a command-line "-le".  The remaining arguments are file names.
862# Print the name of each file that does not end in exactly one newline byte.
863# I.e., warn if there are blank lines (2 or more newlines), or if the
864# last byte is not a newline.  However, currently we don't complain
865# about any file that contains exactly one byte.
866# Exit nonzero if at least one such file is found, otherwise, exit 0.
867# Warn about, but otherwise ignore open failure.  Ignore seek/read failure.
868#
869# Use this if you want to remove trailing empty lines from selected files:
870#   perl -pi -0777 -e 's/\n\n+$/\n/' files...
871#
872require_exactly_one_NL_at_EOF_ =					\
873  foreach my $$f (@ARGV)						\
874    {									\
875      open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next;	\
876      my $$p = sysseek (F, -2, 2);					\
877      my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
878      my $$last_two_bytes;						\
879      defined $$p and $$p = sysread F, $$last_two_bytes, 2;		\
880      close F;								\
881      $$c = "ignore read failure";					\
882      $$p && ($$last_two_bytes eq "\n\n"				\
883              || substr ($$last_two_bytes,1) ne "\n")			\
884          and (print $$f), $$fail=1;					\
885    }									\
886  END { exit defined $$fail }
887sc_prohibit_empty_lines_at_EOF:
888	@perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
889	  || { echo '$(ME): empty line(s) or no newline at EOF'		\
890		1>&2; exit 1; } || :
891
892# Make sure we don't use st_blocks.  Use ST_NBLOCKS instead.
893# This is a bit of a kludge, since it prevents use of the string
894# even in comments, but for now it does the job with no false positives.
895sc_prohibit_stat_st_blocks:
896	@prohibit='[.>]st_blocks'					\
897	halt='do not use st_blocks; use ST_NBLOCKS'			\
898	  $(_sc_search_regexp)
899
900# Make sure we don't define any S_IS* macros in src/*.c files.
901# They're already defined via gnulib's sys/stat.h replacement.
902sc_prohibit_S_IS_definition:
903	@prohibit='^ *# *define  *S_IS'					\
904	halt='do not define S_IS* macros; include <sys/stat.h>'		\
905	  $(_sc_search_regexp)
906
907# Perl block to convert a match to FILE_NAME:LINENO:TEST,
908# that is shared by two definitions below.
909perl_filename_lineno_text_ =						\
910    -e '  {'								\
911    -e '    $$n = ($$` =~ tr/\n/\n/ + 1);'				\
912    -e '    ($$v = $$&) =~ s/\n/\\n/g;'					\
913    -e '    print "$$ARGV:$$n:$$v\n";'					\
914    -e '  }'
915
916prohibit_doubled_word_RE_ ?= \
917  /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
918prohibit_doubled_word_ =						\
919    -e 'while ($(prohibit_doubled_word_RE_))'				\
920    $(perl_filename_lineno_text_)
921
922# Define this to a regular expression that matches
923# any filename:dd:match lines you want to ignore.
924# The default is to ignore no matches.
925ignore_doubled_word_match_RE_ ?= ^$$
926
927sc_prohibit_doubled_word:
928	@perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT))	\
929	  | grep -vE '$(ignore_doubled_word_match_RE_)'			\
930	  | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
931
932# A regular expression matching undesirable combinations of words like
933# "can not"; this matches them even when the two words appear on different
934# lines, but not when there is an intervening delimiter like "#" or "*".
935# Similarly undesirable, "See @xref{...}", since an @xref should start
936# a sentence.  Explicitly prohibit any prefix of "see" or "also".
937# Also prohibit a prefix matching "\w+ +".
938# @pxref gets the same see/also treatment and should be parenthesized;
939# presume it must *not* start a sentence.
940bad_xref_re_ ?= (?:[\w,:;] +|(?:see|also)\s+)\@xref\{
941bad_pxref_re_ ?= (?:[.!?]|(?:see|also))\s+\@pxref\{
942prohibit_undesirable_word_seq_RE_ ?=					\
943  /(?:\bcan\s+not\b|$(bad_xref_re_)|$(bad_pxref_re_))/gims
944prohibit_undesirable_word_seq_ =					\
945    -e 'while ($(prohibit_undesirable_word_seq_RE_))'			\
946    $(perl_filename_lineno_text_)
947# Define this to a regular expression that matches
948# any filename:dd:match lines you want to ignore.
949# The default is to ignore no matches.
950ignore_undesirable_word_sequence_RE_ ?= ^$$
951
952sc_prohibit_undesirable_word_seq:
953	@perl -n -0777 $(prohibit_undesirable_word_seq_)		\
954	     $$($(VC_LIST_EXCEPT))					\
955	  | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep .	\
956	  && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
957
958_ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
959_ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
960# Using test's -a and -o operators is not portable.
961# We prefer test over [, since the latter is spelled [[ in configure.ac.
962sc_prohibit_test_minus_ao:
963	@prohibit='(\<test| \[+) .+ -[ao] '				\
964	halt='$(_ptm1); $(_ptm2)'					\
965	  $(_sc_search_regexp)
966
967# Avoid a test bashism.
968sc_prohibit_test_double_equal:
969	@prohibit='(\<test| \[+) .+ == '				\
970	containing='#! */bin/[a-z]*sh'					\
971	halt='use "test x = x", not "test x =''= x"'			\
972	  $(_sc_search_regexp)
973
974# Each program that uses proper_name_utf8 must link with one of the
975# ICONV libraries.  Otherwise, some ICONV library must appear in LDADD.
976# The perl -0777 invocation below extracts the possibly-multi-line
977# definition of LDADD from the appropriate Makefile.am and exits 0
978# when it contains "ICONV".
979sc_proper_name_utf8_requires_ICONV:
980	@progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
981	if test "x$$progs" != x; then					\
982	  fail=0;							\
983	  for p in $$progs; do						\
984	    dir=$$(dirname "$$p");					\
985	    perl -0777							\
986	      -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)'	\
987	      $$dir/Makefile.am && continue;				\
988	    base=$$(basename "$$p" .c);					\
989	    grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null	\
990	      || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
991	  done;								\
992	  test $$fail = 1 &&						\
993	    { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
994	      exit 1; } || :;						\
995	fi
996
997# Warn about "c0nst struct Foo const foo[]",
998# but not about "char const *const foo" or "#define const const".
999sc_redundant_const:
1000	@prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b'		\
1001	halt='redundant "const" in declarations'			\
1002	  $(_sc_search_regexp)
1003
1004sc_const_long_option:
1005	@prohibit='^ *static.*struct option '				\
1006	exclude='const struct option|struct option const'		\
1007	halt='$(ME): add "const" to the above declarations'		\
1008	  $(_sc_search_regexp)
1009
1010NEWS_hash =								\
1011  $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p'		\
1012       $(srcdir)/NEWS							\
1013     | perl -0777 -pe							\
1014	's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms'	\
1015     | md5sum -								\
1016     | sed 's/ .*//')
1017
1018# Ensure that we don't accidentally insert an entry into an old NEWS block.
1019sc_immutable_NEWS:
1020	@if test -f $(srcdir)/NEWS; then				\
1021	  test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : ||		\
1022	    { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; };	\
1023	fi
1024
1025# Update the hash stored above.  Do this after each release and
1026# for any corrections to old entries.
1027update-NEWS-hash: NEWS
1028	perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1029	  $(srcdir)/cfg.mk
1030
1031# Ensure that we use only the standard $(VAR) notation,
1032# not @...@ in Makefile.am, now that we can rely on automake
1033# to emit a definition for each substituted variable.
1034# However, there is still one case in which @VAR@ use is not just
1035# legitimate, but actually required: when augmenting an automake-defined
1036# variable with a prefix.  For example, gettext uses this:
1037# MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1038# otherwise, makeinfo would put German or French (current locale)
1039# navigation hints in the otherwise-English documentation.
1040#
1041# Allow the package to add exceptions via a hook in cfg.mk;
1042# for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1043# setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1044_makefile_at_at_check_exceptions ?=
1045sc_makefile_at_at_check:
1046	@perl -ne '/\@\w+\@/'						\
1047          -e ' && !/(\w+)\s+=.*\@\1\@$$/'				\
1048          -e ''$(_makefile_at_at_check_exceptions)			\
1049	  -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}'	\
1050	    $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1051	  && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1052
1053news-check: NEWS
1054	if sed -n $(news-check-lines-spec)p $(srcdir)/NEWS		\
1055	    | grep -E $(news-check-regexp) >/dev/null; then		\
1056	  :;								\
1057	else								\
1058	  echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2;	\
1059	  exit 1;							\
1060	fi
1061
1062sc_makefile_TAB_only_indentation:
1063	@prohibit='^	[ ]{8}'						\
1064	in_vc_files='akefile|\.mk$$'					\
1065	halt='found TAB-8-space indentation'				\
1066	  $(_sc_search_regexp)
1067
1068sc_m4_quote_check:
1069	@prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]'		\
1070	in_vc_files='(^configure\.ac|\.m4)$$'				\
1071	halt='quote the first arg to AC_DEF*'				\
1072	  $(_sc_search_regexp)
1073
1074fix_po_file_diag = \
1075'you have changed the set of files with translatable diagnostics;\n\
1076apply the above patch\n'
1077
1078# Verify that all source files using _() are listed in po/POTFILES.in.
1079po_file ?= $(srcdir)/po/POTFILES.in
1080generated_files ?= $(srcdir)/lib/*.[ch]
1081sc_po_check:
1082	@if test -f $(po_file); then					\
1083	  grep -E -v '^(#|$$)' $(po_file)				\
1084	    | grep -v '^src/false\.c$$' | sort > $@-1;			\
1085	  files=;							\
1086	  for file in $$($(VC_LIST_EXCEPT)) $(generated_files); do	\
1087	    test -r $$file || continue;					\
1088	    case $$file in						\
1089	      *.m4|*.mk) continue ;;					\
1090	      *.?|*.??) ;;						\
1091	      *) continue;;						\
1092	    esac;							\
1093	    case $$file in						\
1094	    *.[ch])							\
1095	      base=`expr " $$file" : ' \(.*\)\..'`;			\
1096	      { test -f $$base.l || test -f $$base.y; } && continue;;	\
1097	    esac;							\
1098	    files="$$files $$file";					\
1099	  done;								\
1100	  grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files		\
1101	    | sed 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2;	\
1102	  diff -u -L $(po_file) -L $(po_file) $@-1 $@-2			\
1103	    || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; };	\
1104	  rm -f $@-1 $@-2;						\
1105	fi
1106
1107# Sometimes it is useful to change the PATH environment variable
1108# in Makefiles.  When doing so, it's better not to use the Unix-centric
1109# path separator of ':', but rather the automake-provided '$(PATH_SEPARATOR)'.
1110msg = '$(ME): Do not use ":" above; use $$(PATH_SEPARATOR) instead'
1111sc_makefile_path_separator_check:
1112	@prohibit='PATH[=].*:'						\
1113	in_vc_files='akefile|\.mk$$'					\
1114	halt=$(msg)							\
1115	  $(_sc_search_regexp)
1116
1117# Check that 'make alpha' will not fail at the end of the process,
1118# i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1119# and is read-only.
1120writable-files:
1121	if test -d $(release_archive_dir); then				\
1122	  for file in $(DIST_ARCHIVES); do				\
1123	    for p in ./ $(release_archive_dir)/; do			\
1124	      test -e $$p$$file || continue;				\
1125	      test -w $$p$$file						\
1126		|| { echo ERROR: $$p$$file is not writable; fail=1; };	\
1127	    done;							\
1128	  done;								\
1129	  test "$$fail" && exit 1 || : ;				\
1130	else :;								\
1131	fi
1132
1133v_etc_file = $(gnulib_dir)/lib/version-etc.c
1134sample-test = tests/sample-test
1135texi = doc/$(PACKAGE).texi
1136# Make sure that the copyright date in $(v_etc_file) is up to date.
1137# Do the same for the $(sample-test) and the main doc/.texi file.
1138sc_copyright_check:
1139	@require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };'		\
1140	in_files=$(v_etc_file)						\
1141	halt='out of date copyright in $(v_etc_file); update it'	\
1142	  $(_sc_search_regexp)
1143	@require='# Copyright \(C\) '$$(date +%Y)' Free'		\
1144	in_vc_files=$(sample-test)					\
1145	halt='out of date copyright in $(sample-test); update it'	\
1146	  $(_sc_search_regexp)
1147	@require='Copyright @copyright\{\} .*'$$(date +%Y)' Free'	\
1148	in_vc_files=$(texi)						\
1149	halt='out of date copyright in $(texi); update it'		\
1150	  $(_sc_search_regexp)
1151
1152# If tests/help-version exists and seems to be new enough, assume that its
1153# use of init.sh and path_prepend_ is correct, and ensure that every other
1154# use of init.sh is identical.
1155# This is useful because help-version cross-checks prog --version
1156# with $(VERSION), which verifies that its path_prepend_ invocation
1157# sets PATH correctly.  This is an inexpensive way to ensure that
1158# the other init.sh-using tests also get it right.
1159_hv_file ?= $(srcdir)/tests/help-version
1160_hv_regex_weak ?= ^ *\. .*/init\.sh"
1161# Fix syntax-highlighters "
1162_hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1163sc_cross_check_PATH_usage_in_tests:
1164	@if test -f $(_hv_file); then					\
1165	  grep -l 'VERSION mismatch' $(_hv_file) >/dev/null		\
1166	    || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2;	\
1167		 exit 0; };						\
1168	  grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null		\
1169	    || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1170		 exit 1; };						\
1171	  good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file));		\
1172	  grep -LFx "$$good"						\
1173		$$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT)))	\
1174	      | grep . &&						\
1175	    { echo "$(ME): the above files use path_prepend_ inconsistently" \
1176		1>&2; exit 1; } || :;					\
1177	fi
1178
1179# BRE regex of file contents to identify a test script.
1180_test_script_regex ?= \<init\.sh\>
1181
1182# In tests, use "compare expected actual", not the reverse.
1183sc_prohibit_reversed_compare_failure:
1184	@prohibit='\<compare [^ ]+ ([^ ]*exp|/dev/null)'		\
1185	containing='$(_test_script_regex)'				\
1186	halt='reversed compare arguments'				\
1187	  $(_sc_search_regexp)
1188
1189# #if HAVE_... will evaluate to false for any non numeric string.
1190# That would be flagged by using -Wundef, however gnulib currently
1191# tests many undefined macros, and so we can't enable that option.
1192# So at least preclude common boolean strings as macro values.
1193sc_Wundef_boolean:
1194	@prohibit='^#define.*(yes|no|true|false)$$'			\
1195	in_files='$(CONFIG_INCLUDE)'					\
1196	halt='Use 0 or 1 for macro values'				\
1197	  $(_sc_search_regexp)
1198
1199# Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1200# not be constant, or might overflow a stack.  In general, use PATH_MAX as
1201# a limit, not an array or alloca size.
1202sc_prohibit_path_max_allocation:
1203	@prohibit='(\balloca *\([^)]*|\[[^]]*)PATH_MAX'			\
1204	halt='Avoid stack allocations of size PATH_MAX'			\
1205	  $(_sc_search_regexp)
1206
1207sc_vulnerable_makefile_CVE-2009-4029:
1208	@prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1209	in_files=$$(find $(srcdir) -name Makefile.in)			\
1210	halt=$$(printf '%s\n'						\
1211	  'the above files are vulnerable; beware of running'		\
1212	  '  "make dist*" rules, and upgrade to fixed automake'		\
1213	  '  see http://bugzilla.redhat.com/542609 for details')	\
1214	  $(_sc_search_regexp)
1215
1216vc-diff-check:
1217	(unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1218	if test -s vc-diffs; then				\
1219	  cat vc-diffs;						\
1220	  echo "Some files are locally modified:" 1>&2;		\
1221	  exit 1;						\
1222	else							\
1223	  rm vc-diffs;						\
1224	fi
1225
1226rel-files = $(DIST_ARCHIVES)
1227
1228gnulib_dir ?= $(srcdir)/gnulib
1229gnulib-version = $$(cd $(gnulib_dir) && git describe)
1230bootstrap-tools ?= autoconf,automake,gnulib
1231
1232# If it's not already specified, derive the GPG key ID from
1233# the signed tag we've just applied to mark this release.
1234gpg_key_ID ?= \
1235  $$(git cat-file tag v$(VERSION) \
1236     | gpgv --status-fd 1 --keyring /dev/null - - 2>/dev/null \
1237     | sed -n '/^\[GNUPG:\] ERRSIG /{s///;s/ .*//p;q}')
1238
1239translation_project_ ?= coordinator@translationproject.org
1240
1241# Make info-gnu the default only for a stable release.
1242ifeq ($(RELEASE_TYPE),stable)
1243  announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1244  announcement_mail_headers_ ?=						\
1245    To: info-gnu@gnu.org						\
1246    Cc: $(announcement_Cc_)						\
1247    Mail-Followup-To: $(PACKAGE_BUGREPORT)
1248else
1249  announcement_Cc_ ?= $(translation_project_)
1250  announcement_mail_headers_ ?=						\
1251    To: $(PACKAGE_BUGREPORT)						\
1252    Cc: $(announcement_Cc_)
1253endif
1254
1255announcement: NEWS ChangeLog $(rel-files)
1256	@$(srcdir)/$(_build-aux)/announce-gen				\
1257	    --mail-headers='$(announcement_mail_headers_)'		\
1258	    --release-type=$(RELEASE_TYPE)				\
1259	    --package=$(PACKAGE)					\
1260	    --prev=$(PREV_VERSION)					\
1261	    --curr=$(VERSION)						\
1262	    --gpg-key-id=$(gpg_key_ID)					\
1263	    --news=$(srcdir)/NEWS					\
1264	    --bootstrap-tools=$(bootstrap-tools)			\
1265	    $$(case ,$(bootstrap-tools), in (*,gnulib,*)		\
1266	       echo --gnulib-version=$(gnulib-version);; esac)		\
1267	    --no-print-checksums					\
1268	    $(addprefix --url-dir=, $(url_dir_list))
1269
1270## ---------------- ##
1271## Updating files.  ##
1272## ---------------- ##
1273
1274ftp-gnu = ftp://ftp.gnu.org/gnu
1275www-gnu = http://www.gnu.org
1276
1277upload_dest_dir_ ?= $(PACKAGE)
1278emit_upload_commands:
1279	@echo =====================================
1280	@echo =====================================
1281	@echo "$(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \\"
1282	@echo "    --to $(gnu_rel_host):$(upload_dest_dir_) \\"
1283	@echo "  $(rel-files)"
1284	@echo '# send the ~/announce-$(my_distdir) e-mail'
1285	@echo =====================================
1286	@echo =====================================
1287
1288define emit-commit-log
1289  printf '%s\n' 'maint: post-release administrivia' ''			\
1290    '* NEWS: Add header line for next release.'				\
1291    '* .prev-version: Record previous version.'				\
1292    '* cfg.mk (old_NEWS_hash): Auto-update.'
1293endef
1294
1295.PHONY: no-submodule-changes
1296no-submodule-changes:
1297	if test -d $(srcdir)/.git; then					\
1298	  diff=$$(cd $(srcdir) && git submodule -q foreach		\
1299		  git diff-index --name-only HEAD)			\
1300	    || exit 1;							\
1301	  case $$diff in '') ;;						\
1302	    *) echo '$(ME): submodule files are locally modified:';	\
1303		echo "$$diff"; exit 1;; esac;				\
1304	else								\
1305	  : ;								\
1306	fi
1307
1308submodule-checks ?= no-submodule-changes public-submodule-commit
1309
1310# Ensure that each sub-module commit we're using is public.
1311# Without this, it is too easy to tag and release code that
1312# cannot be built from a fresh clone.
1313.PHONY: public-submodule-commit
1314public-submodule-commit:
1315	$(AM_V_GEN)if test -d $(srcdir)/.git; then			\
1316	  cd $(srcdir) &&						\
1317	  git submodule --quiet foreach test '$$(git rev-parse $$sha1)'	\
1318	      = '$$(git merge-base origin $$sha1)'			\
1319	    || { echo '$(ME): found non-public submodule commit' >&2;	\
1320		 exit 1; };						\
1321	else								\
1322	  : ;								\
1323	fi
1324# This rule has a high enough utility/cost ratio that it should be a
1325# dependent of "check" by default.  However, some of us do occasionally
1326# commit a temporary change that deliberately points to a non-public
1327# submodule commit, and want to be able to use rules like "make check".
1328# In that case, run e.g., "make check gl_public_submodule_commit="
1329# to disable this test.
1330gl_public_submodule_commit ?= public-submodule-commit
1331check: $(gl_public_submodule_commit)
1332
1333.PHONY: alpha beta stable
1334ALL_RECURSIVE_TARGETS += alpha beta stable
1335alpha beta stable: $(local-check) writable-files $(submodule-checks)
1336	test $@ = stable						\
1337	  && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$'		\
1338	       || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1339	  || :
1340	$(MAKE) vc-diff-check
1341	$(MAKE) news-check
1342	$(MAKE) distcheck
1343	$(MAKE) dist
1344	$(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1345	$(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1346
1347# Override this in cfg.mk if you follow different procedures.
1348release-prep-hook ?= release-prep
1349
1350gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1351.PHONY: release-prep
1352release-prep:
1353	case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1354	  *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
1355	$(MAKE) --no-print-directory -s announcement > ~/announce-$(my_distdir)
1356	if test -d $(release_archive_dir); then			\
1357	  ln $(rel-files) $(release_archive_dir);		\
1358	  chmod a-w $(rel-files);				\
1359	fi
1360	echo $(VERSION) > $(prev_version_file)
1361	$(MAKE) update-NEWS-hash
1362	perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' NEWS
1363	$(emit-commit-log) > .ci-msg
1364	$(VC) commit -F .ci-msg -a
1365	rm .ci-msg
1366
1367# Override this with e.g., -s $(srcdir)/some_other_name.texi
1368# if the default $(PACKAGE)-derived name doesn't apply.
1369gendocs_options_ ?=
1370
1371.PHONY: web-manual
1372web-manual:
1373	@test -z "$(manual_title)" \
1374	  && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1375	@cd '$(srcdir)/doc'; \
1376	  $(SHELL) ../$(_build-aux)/gendocs.sh $(gendocs_options_) \
1377	     -o '$(abs_builddir)/doc/manual' \
1378	     --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1379	    "$(PACKAGE_NAME) - $(manual_title)"
1380	@echo " *** Upload the doc/manual directory to web-cvs."
1381
1382# Code Coverage
1383
1384init-coverage:
1385	$(MAKE) $(AM_MAKEFLAGS) clean
1386	lcov --directory . --zerocounters
1387
1388COVERAGE_CCOPTS ?= "-g --coverage"
1389COVERAGE_OUT ?= doc/coverage
1390
1391build-coverage:
1392	$(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1393	$(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1394	mkdir -p $(COVERAGE_OUT)
1395	lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1396		--capture
1397
1398gen-coverage:
1399	genhtml --output-directory $(COVERAGE_OUT) \
1400		$(COVERAGE_OUT)/$(PACKAGE).info \
1401		--highlight --frames --legend \
1402		--title "$(PACKAGE_NAME)"
1403
1404coverage: init-coverage build-coverage gen-coverage
1405
1406# Update gettext files.
1407PACKAGE ?= $(shell basename $(PWD))
1408PO_DOMAIN ?= $(PACKAGE)
1409POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1410PODIR ?= po
1411refresh-po:
1412	rm -f $(PODIR)/*.po && \
1413	echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1414	wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1415	echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1416	echo 'en@quot' >> $(PODIR)/LINGUAS && \
1417	ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1418
1419 # Running indent once is not idempotent, but running it twice is.
1420INDENT_SOURCES ?= $(C_SOURCES)
1421.PHONY: indent
1422indent:
1423	indent $(INDENT_SOURCES)
1424	indent $(INDENT_SOURCES)
1425
1426# If you want to set UPDATE_COPYRIGHT_* environment variables,
1427# put the assignments in this variable.
1428update-copyright-env ?=
1429
1430# Run this rule once per year (usually early in January)
1431# to update all FSF copyright year lists in your project.
1432# If you have an additional project-specific rule,
1433# add it in cfg.mk along with a line 'update-copyright: prereq'.
1434# By default, exclude all variants of COPYING; you can also
1435# add exemptions (such as ChangeLog..* for rotated change logs)
1436# in the file .x-update-copyright.
1437.PHONY: update-copyright
1438update-copyright:
1439	grep -l -w Copyright                                             \
1440	  $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1441	  | $(update-copyright-env) xargs $(srcdir)/$(_build-aux)/$@
1442
1443# This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1444# overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1445
1446# NOTE: to override any _gl_TS_* default value, you must
1447# define the variable(s) using "export" in cfg.mk.
1448_gl_TS_dir ?= src
1449
1450ALL_RECURSIVE_TARGETS += sc_tight_scope
1451sc_tight_scope: tight-scope.mk
1452	@fail=0;							\
1453	if ! grep '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk	\
1454		> /dev/null						\
1455	   && ! grep -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1456		> /dev/null 2>&1; then					\
1457	    echo '$(ME): skipping $@';					\
1458	else								\
1459	    $(MAKE) -s -C $(_gl_TS_dir)					\
1460		-f Makefile						\
1461		-f $(abs_top_srcdir)/cfg.mk				\
1462		-f $(abs_top_builddir)/$<				\
1463	      _gl_tight_scope						\
1464		|| fail=1;						\
1465	fi;								\
1466	rm -f $<;							\
1467	exit $$fail
1468
1469tight-scope.mk: $(ME)
1470	@rm -f $@ $@-t
1471	@perl -ne '/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME) > $@-t
1472	@chmod a=r $@-t && mv $@-t $@
1473
1474ifeq (a,b)
1475# TS-start
1476
1477# Most functions should have static scope.
1478# Any that don't must be marked with 'extern', but 'main'
1479# and 'usage' are exceptions: they're always extern, but
1480# do not need to be marked.  Symbols matching '__.*' are
1481# reserved by the compiler, so are automatically excluded below.
1482_gl_TS_unmarked_extern_functions ?= main usage
1483_gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\S+) *\(/
1484
1485# If your project uses a macro like "XTERN", then put
1486# the following in cfg.mk to override this default:
1487# export _gl_TS_extern = extern|XTERN
1488_gl_TS_extern ?= extern
1489
1490# The second nm|grep checks for file-scope variables with 'extern' scope.
1491# Without gnulib's progname module, you might put program_name here.
1492# Symbols matching '__.*' are reserved by the compiler,
1493# so are automatically excluded below.
1494_gl_TS_unmarked_extern_vars ?=
1495
1496# NOTE: the _match variables are perl expressions -- not mere regular
1497# expressions -- so that you can extend them to match other patterns
1498# and easily extract matched variable names.
1499# For example, if your project declares some global variables via
1500# a macro like this: GLOBAL(type, var_name, initializer), then you
1501# can override this definition to automatically extract those names:
1502# export _gl_TS_var_match = \
1503#   /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1504_gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
1505
1506# The names of object files in (or relative to) $(_gl_TS_dir).
1507_gl_TS_obj_files ?= *.$(OBJEXT)
1508
1509# Files in which to search for the one-line style extern declarations.
1510# $(_gl_TS_dir)-relative.
1511_gl_TS_headers ?= $(noinst_HEADERS)
1512
1513.PHONY: _gl_tight_scope
1514_gl_tight_scope: $(bin_PROGRAMS)
1515	t=exceptions-$$$$;						\
1516	trap 's=$$?; rm -f $$t; exit $$s' 0;				\
1517	for sig in 1 2 3 13 15; do					\
1518	  eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1519	done;								\
1520	src=`for f in $(SOURCES); do					\
1521	       test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;	\
1522	hdr=`for f in $(_gl_TS_headers); do				\
1523	       test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;	\
1524	( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions);	\
1525	  grep -h -A1 '^extern .*[^;]$$' $$src				\
1526	    | grep -vE '^(extern |--)' | sed 's/ .*//';			\
1527	  perl -lne							\
1528	     '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr;	\
1529	) | sort -u > $$t;						\
1530	nm -e $(_gl_TS_obj_files) | sed -n 's/.* T //p'|grep -Ev -f $$t	\
1531	  && { echo the above functions should have static scope >&2;	\
1532	       exit 1; } || : ;						\
1533	( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars);	\
1534	  perl -lne '$(_gl_TS_var_match) and print "^$$1\$$"' $$hdr *.h	\
1535	) | sort -u > $$t;						\
1536	nm -e $(_gl_TS_obj_files) | sed -n 's/.* [BCDGRS] //p'		\
1537            | sort -u | grep -Ev -f $$t					\
1538	  && { echo the above variables should have static scope >&2;	\
1539	       exit 1; } || :
1540# TS-end
1541endif
1542